=== CherryPi/torchcraft/examples/cpp/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6 FATAL_ERROR)
CMAKE_POLICY(VERSION 2.6)

SET(CMAKE_CXX_FLAGS "-std=c++11 -Wall")

FIND_PACKAGE(Torch REQUIRED)
FIND_PACKAGE(gflags REQUIRED)
INCLUDE_DIRECTORIES("${Torch_INSTALL_INCLUDE}/torchcraft")

ADD_EXECUTABLE(simple_dll simple_dll.cpp)
TARGET_LINK_LIBRARIES(simple_dll torchcraft gflags)
