=== CherryPi/torchcraft/BWEnv/include/czmq/packaging/debian/control ===
#
#    czmq - The high-level C binding for 0MQ
#
#    Copyright (c) the Contributors as noted in the AUTHORS file.       
#    This file is part of CZMQ, the high-level C binding for 0MQ:       
#    http://czmq.zeromq.org.                                            
#                                                                       
#    This Source Code Form is subject to the terms of the Mozilla Public
#    License, v. 2.0. If a copy of the MPL was not distributed with this
#    file, You can obtain one at http://mozilla.org/MPL/2.0/.           

Source:         czmq
Section:        net
Priority:       optional
Maintainer:     czmq Developers <zeromq-dev@lists.zeromq.org>
Standards-Version: 3.9.7
Build-Depends: debhelper (>= 9),
    pkg-config,
    dh-autoreconf,
    libzmq3-dev,
    uuid-dev,
    libsystemd-dev,
Build-Depends-Indep: asciidoc,
                     xmlto

Package: libczmq4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: czmq
 This package contains shared library for czmq: the high-level c binding for 0mq

Package: libczmq-dev
Architecture: any
Section: libdevel
Depends:
    libzmq3-dev,
    uuid-dev,
    libsystemd-dev,
    libczmq4 (= ${binary:Version})
Description: development files for czmq
 This package contains development files for czmq: the high-level c binding for 0mq

Package: czmq
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: the high-level c binding for 0mq
 Main package for czmq: the high-level c binding for 0mq

Package: czmq-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
    czmq (= ${binary:Version}),
    ${misc:Depends}
Description: debugging symbols for czmq
 This package contains the debugging symbols for czmq : the high-level c binding for 0mq.
